#ifndef TPU_ISRSOURCE_H
#define TPU_ISRSOURCE_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/hal/imb3_isrsource.h"

#if !defined(CYG_HAL_STARTUP_STUBS) && defined(CYG_HAL_MPC555)
//------------------
// Class declaration
//------------------
class TPU_isrSource : public IMB3_isrSource
{
  public:
    typedef enum {
      TPU_A,
      TPU_B
    } TPU_IDENTIFICATION;
                    TPU_isrSource(IMB3_isrDispatcher * a_dispatcher,
                                  unsigned char a_isrpriority,
                                  TPU_IDENTIFICATION a_identification);
    virtual         ~TPU_isrSource();

    // Overloaded virtual from base class IMB3_isrSource
    virtual cyg_uint32 findInterruptingVector(unsigned char a_priority);
    virtual void       enableInterrupts(void);
    virtual void       disableInterrupts(void);

  private:
    unsigned char      m_priority;
    TPU_IDENTIFICATION m_identification;
};
#endif // if !defined ...

#endif // TPU_ISRSOURCE_H
